#include "../../Decryptor/Decryptor_u.h"
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include "Ipc.h"
#include "protobufLAInitiator.h"
#include "PostLAProtobufNativeTransforms.h"
#include "protobufReadWrite.h"
#include "PostLAMessages.pb.h"
#include "FileIO.h"

namespace LocalAttestationUntrusted {
   int setup_socket_for_local_attestation_requests(int port);
   int prepare_local_attestation_as_responder_msg1(uint32_t own_enclave_id);
   int local_attestation_as_responder_msg2_msg3(uint32_t own_enclave_id, int server_fd, int * accept_fd);
   uint32_t get_decrypted_client_data(uint8_t* array, uint32_t array_length);
   int post_local_attestation_with_verifier(uint32_t own_enclave_id, int apache_fd);
   int post_local_attestation_with_apache(uint32_t own_enclave_id, int apache_fd);
};
