//
// Created by miti on 27/07/19.
//

#ifndef DECRYPTORAPP_POSTLAPROTOBUFNATIVETRANSFORMS_H
#define DECRYPTORAPP_POSTLAPROTOBUFNATIVETRANSFORMS_H
#include "PostLAMessages.pb.h"

namespace PostLAProtobufNativeTransforms {
    void get_lengths_for_protobuf_serialized_array(extension_to_decryptor_enclosed_msg &protobuf_ext_to_decryptor,
                                                                                   uint32_t *op_ciphertext_length,
                                                                                   uint32_t *op_number_of_ciphertext_fields);

    void create_array_from_protobuf(extension_to_decryptor_enclosed_msg &protobuf_ext_to_decryptor,
                                                                    unsigned char* double_ciphertext_client_data,
                                                                    uint32_t* sizes_array,
                                                                    uint32_t* sizes_array_length);

    void create_protobuf_from_array(   unsigned char* ciphertext_client_data, uint32_t* sizes_array,
            uint32_t sizes_array_length,
            extension_to_decryptor_enclosed_msg protobuf_extension_decryptor_msg);
};


#endif //DECRYPTORAPP_POSTLAPROTOBUFNATIVETRANSFORMS_H
