#include <stdint.h>
#include "../TrustedInclude/Decryptor.h"
#include "Decryptor_t.h"
/*
uint32_t process_apache_message_generate_response_wrapper(uint8_t* input_ciphertext,
        uint32_t input_ciphertext_plus_tag_length, uint8_t* output_ciphertext,
        uint32_t* output_ciphertext_plus_tag_length)
{
  return Decryptor::process_apache_message_generate_response(input_ciphertext, input_ciphertext_plus_tag_length, output_ciphertext, output_ciphertext_plus_tag_length);
}
*/
uint32_t process_apache_message_generate_response_wrapper(
        uint8_t* double_ciphertext,
        uint32_t double_ciphertext_length,
        uint32_t* double_ciphertext_fields_lengths,
        uint32_t number_of_double_ciphertext_fields,
        uint8_t* output_ciphertext,
        uint32_t* output_sizes_array)
{
    return Decryptor::process_apache_message_generate_response(
            double_ciphertext,
            double_ciphertext_length,
            double_ciphertext_fields_lengths,
            number_of_double_ciphertext_fields,
            output_ciphertext,
            output_sizes_array);
}

uint32_t process_verifiers_message_wrapper(uint8_t* input_ciphertext, uint32_t length)
{
  return Decryptor::process_verifiers_message(input_ciphertext, length);
}

uint32_t create_and_encrypt_mitigator_header_H_wrapper(uint8_t* ciphertext_token_H_plus_tag, uint32_t* length)
{
  return Decryptor::create_and_encrypt_mitigator_header_H(ciphertext_token_H_plus_tag, length);
}

void calculate_sealed_keypair_size_wrapper(size_t* length)
{
  Decryptor::calculate_sealed_keypair_size(length);
}

uint32_t create_and_seal_long_term_signing_key_pair_wrapper(size_t* sealed_data_length, uint8_t* sealed_data)
{
     return Decryptor::create_and_seal_long_term_signing_key_pair(sealed_data_length, sealed_data);
}

uint32_t unseal_and_restore_long_term_signing_key_pair_wrapper(uint8_t* sealed_data, size_t* sgx_sealed_data_length)
{
  return Decryptor::unseal_and_restore_long_term_signing_key_pair(sealed_data, sgx_sealed_data_length);
}

void get_verifier_mrenclave_apache_mrsigner_wrapper(uint8_t* output)
{
	Decryptor::testing_get_verifier_mrenclave_apache_mrsigner(output);
}

void get_short_term_public_key_wrapper(uint8_t* output)
{
	Decryptor::testing_get_short_term_public_key(output);
}

void get_long_term_verification_key_wrapper(uint8_t* output)
{
	Decryptor::testing_long_term_verification_key(output);
}

void get_apache_iv(uint8_t* op)
{
	Decryptor::testing_get_apache_iv(op);
}

uint32_t session_request_wrapper(sgx_dh_msg1_t *dh_msg1, uint32_t *session_id)
{
    // return LA::session_request(dh_msg1, session_id);
    return 0;
}

uint32_t exchange_report_wrapper(sgx_dh_msg2_t *dh_msg2, sgx_dh_msg3_t *dh_msg3, uint32_t *session_id)
{
    // return LA::exchange_report(dh_msg2, dh_msg3, session_id);
    return 0;
}